import controlP5.*;

import peasy.test.*;
import peasy.org.apache.commons.math.*;
import peasy.*;
import peasy.org.apache.commons.math.geometry.*;

import de.fhpotsdam.unfolding.mapdisplay.*;
import de.fhpotsdam.unfolding.utils.*;
import de.fhpotsdam.unfolding.marker.*;
import de.fhpotsdam.unfolding.tiles.*;
import de.fhpotsdam.unfolding.interactions.*;
import de.fhpotsdam.unfolding.ui.*;
import de.fhpotsdam.unfolding.*;
import de.fhpotsdam.unfolding.core.*;
import de.fhpotsdam.unfolding.mapdisplay.shaders.*;
import de.fhpotsdam.unfolding.data.*;
import de.fhpotsdam.unfolding.geo.*;
import de.fhpotsdam.unfolding.texture.*;
import de.fhpotsdam.unfolding.events.*;
import de.fhpotsdam.utils.*;
import de.fhpotsdam.unfolding.providers.*;

import de.fhpotsdam.unfolding.providers.EsriProvider.WorldShadedRelief.*;
import de.fhpotsdam.unfolding.providers.EsriProvider.NatGeoWorldMap.*;
import de.fhpotsdam.unfolding.providers.EsriProvider.WorldGrayCanvas.*;
PeasyCam cam;

ParticleSystem ps;
PImage sprite;

ControlP5 cp5;
Slider abc;

PImage wb;

PFont font;

int MapType = 3;
float LineSize = 1.0;
int NumberOfWildebeests = 6;
int VisualizationType = 0;
int StructureColor = 0;
boolean MapToggle = false;

Table table;
int rowCount;
int columnCount;
int whichId = 1;
int aListLength = 371;
boolean done;

String[] Slats = new String[4429];
String[] Slongs = new String[4429];
Float[] lats = new Float[4429];
Float[] longs = new Float[4429];
String[] IDs = new String[4429];
Float[] IdNum = new Float[4429];

int[] colId = {
  1804, 1805, 1806, 1857, 1858, 1859, 1860, 1861, 2175, 2409
};
color[] colors = {
  #6796A6, #9767A6, #76A667, #A67867, #A9B3BA, #B9A9BA, #AABAA9, #A9B3BA, #688F83, #784051
};

PShape s;

ArrayList<Location> locations = new ArrayList<Location>();

UnfoldingMap map1;
UnfoldingMap map2;
UnfoldingMap map3;

public void setup() {
  size(displayWidth, displayHeight, P3D);

  cam = new PeasyCam(this, 600, 600, 600, 700);
  
  cp5 = new ControlP5(this);

  cp5.addToggle("MapToggle")
    .setPosition(20, 820)
      .setColorBackground(color(200))
        .setColorActive(color(150))
          .setColorForeground(color(150))
            .setColorLabel(0)
              //.setSize(50,20)
              ;

  cp5.addSlider("MapType")
    .setPosition(20, 790)
      .setColorBackground(color(200))
        .setColorActive(color(150))
          .setColorForeground(color(150))
            .setColorLabel(0)
              .setColorTickMark(0)
                //.setSize(20,100)
                .setRange(1, 3)
                  .setNumberOfTickMarks(3)
                    ;

  cp5.addSlider("LineSize")
    .setPosition(20, 760)
      .setColorBackground(color(200))
        .setColorActive(color(150))
          .setColorForeground(color(150))
            .setColorLabel(0)
              .setRange(0, 4.5)
                ;

  cp5.addSlider("NumberOfWildebeests")
    .setPosition(20, 730)
      .setColorBackground(color(200))
        .setColorActive(color(150))
          .setColorForeground(color(150))
            .setColorLabel(0)
              .setColorTickMark(0)
                //.setSize(20,100)
                .setRange(1, 10)
                  .setNumberOfTickMarks(10)
                    ;

  cp5.addSlider("VisualizationType")
    .setPosition(20, 700)
      //.setWidth(400)
      .setColorBackground(color(200))
        .setColorActive(color(150))
          .setColorForeground(color(150))
            .setColorLabel(0)
              .setColorTickMark(0)
                .setRange(0, 2) // values can range from big to small as well
                  .setValue(0)
                    .setNumberOfTickMarks(3)
                      .setSliderMode(Slider.FLEXIBLE)
                        ;
                        
  cp5.addSlider("StructureColor")
    .setPosition(20, 670)
      .setColorBackground(color(200))
        .setColorActive(color(150))
          .setColorForeground(color(150))
            .setColorLabel(0)
              .setColorTickMark(0)
                //.setSize(20,100)
                .setRange(1, 3)
                  .setNumberOfTickMarks(3)
                    ;

  cp5.setAutoDraw(false);


  map1 = new UnfoldingMap(this, new EsriProvider.NatGeoWorldMap());
  map2 = new UnfoldingMap(this, new EsriProvider.WorldShadedRelief());
  map3 = new UnfoldingMap(this, new EsriProvider.WorldGrayCanvas());
  
  map1.zoomAndPanTo(new Location(-2.2f, 34.9f), 9);
  map2.zoomAndPanTo(new Location(-2.2f, 34.9f), 9);
  map3.zoomAndPanTo(new Location(-2.2f, 34.9f), 9);

  MapUtils.createDefaultEventDispatcher(this, map1);
  MapUtils.createDefaultEventDispatcher(this, map2);
  MapUtils.createDefaultEventDispatcher(this, map3);

  processData();
}

public void draw() {

  background(255);
  smooth();

  if (done) {
    for (int i=0; i<NumberOfWildebeests-1; i++) {
      drawShape(i, i);
    }
  }

  if (MapToggle == true) {
    if (MapType == 1) {
      map1.draw();
    } else if (MapType == 2) {
      map2.draw();
    } else if (MapType == 3) {
      map3.draw();
    }
  }

  drawGUI();
}

